require 'tmpdir'

require 'crusade/apns/push_notification'
require 'crusade/notification'
require 'crusade/apns/notification'

class Fixtures
  def self.default_configuration
    OpenStruct.new({
      site_name: 'Bay Airlines',
      push_id: 'web.com.example.domain',
      url_format: 'http://domain.example.com/?flight=%@',
      webservice_url: 'https://example.com/push',
      allowed_domains: ['http://example.com'],
      temp_dir: Dir.mktmpdir,
      iconset_dir: 'test/fixtures/icons',

      certificate: 'test/fixtures/ssl/certificate.p12',
      certificate_password: 'test'
    })
  end

  def self.default_notification
    Crusade::Notification.new({
      title: 'the title',
      body: 'the body',
      action: 'submit',
      url_args: ['a'],
      device_token: '1234a'
    })
  end

  def self.default_apns_notification
    Crusade::APNS::Notification.new default_notification, '1234a'
  end
end