require 'openssl'

module SslSupport
  module_function

  def certificate(certificate_file, certificate_password)
    OpenSSL::PKCS12.new(File.read(certificate_file), certificate_password)
  end

  def verify_signature(certificate, file, signature)
    signed = OpenSSL::PKCS7.new(File.read(signature))

    p7 = OpenSSL::PKCS7.new(signed.to_der)
    p7.verify([certificate.certificate], 
               OpenSSL::X509::Store.new, 
               File.read(file), 
               OpenSSL::PKCS7::DETACHED | OpenSSL::PKCS7::NOVERIFY)
  end
end