require File.expand_path '../../test_helper.rb', __FILE__

require 'crusade/apns/notification_encoder'

require 'base64'
require 'fixtures'

describe Crusade::APNS::NotificationEncoder do
  let(:described_class) { Crusade::APNS::NotificationEncoder }

  let(:options) { Fixtures.default_configuration }

  subject { Crusade::APNS::NotificationEncoder.new options }

  describe 'encode' do
    let(:notification) { Fixtures.default_apns_notification }
    let(:expected) do
<<-eof
AQAAAAAAAVGAACASNKAAXHsiYXBzIjp7ImFsZXJ0Ijp7InRpdGxlIjoidGhl
IHRpdGxlIiwiYm9keSI6InRoZSBib2R5IiwiYWN0aW9uIjoic3VibWl0In0s
InVybC1hcmdzIjpbImEiXX19
eof
    end

    let(:encoded) { subject.encode notification }

    it { encoded.must_equal Base64.decode64(expected) }
  end
end