require File.expand_path '../../../test_helper.rb', __FILE__
require 'json'
require 'json_expressions/minitest'

require 'crusade/apns/push_package/directory_structure_generator'

describe Crusade::APNS::DirectoryStructureGenerator do
  let(:options) { Fixtures.default_configuration }

  subject { Crusade::APNS::DirectoryStructureGenerator.new options }

  let(:dir) { subject.generate }

  describe 'generate' do
    after { FileUtils.remove_entry_secure dir }

    it 'creates the directory' do
      Dir.exists?(dir).must_be_truthy
    end

    it 'copies the icon files' do
      %w(16x16 16x16@2x 32x32 32x32@2x 128x128 128x128@2x).each do |size|
        icon = File.join dir, 'icon.iconset', "icon_#{size}.png"

        File.exists?(icon).must_be_truthy
      end
    end
  end

  describe 'clean' do
    it 'removes all the data' do
      dir

      subject.clean

      Dir.exists?(dir).must_equal false
    end
  end
end
