require File.expand_path '../../../test_helper.rb', __FILE__
require 'json'
require 'json_expressions/minitest'

require 'crusade/apns/push_package/website_file_generator'

describe Crusade::APNS::WebsiteFileGenerator do
  let(:user_id) { 187 }  
  let(:options) { Fixtures.default_configuration }

  subject { Crusade::APNS::WebsiteFileGenerator.new user_id, options }

  let(:website_json) { subject.generate }
  let(:parsed) { JSON.parse website_json }

  describe 'generate' do
    before do
      generator = OpenStruct.new generate: 'token'
      Crusade::APNS::UserTokenGenerator.stub(:new, generator) do
        website_json
      end
    end

    it 'builds a valid json' do
      parsed.wont_be_nil
    end

    it 'generate the correct json' do
      expected_json = {
        "websiteName"         => "Bay Airlines",
        "websitePushID"       => "web.com.example.domain",
        "allowedDomains"      => ['http://example.com'],
        "urlFormatString"     => "http://domain.example.com/?flight=%@",
        "authenticationToken" => "token",
        "webServiceURL"       => "https://example.com/push"
      }

      parsed.must_match_json_expression expected_json
    end
  end
end
